(function(modules) {
  var installedModules = {};
  function __webpack_require__(moduleId) {
    if (installedModules[moduleId]) {
      return installedModules[moduleId].exports;
    }
    var module = installedModules[moduleId] = {
      i: moduleId,
      l: false,
      exports: {}
    };
    modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
    module.l = true;
    return module.exports;
  }
  __webpack_require__.m = modules;
  __webpack_require__.c = installedModules;
  __webpack_require__.d = function(exports, name, getter) {
    if (!__webpack_require__.o(exports, name)) {
      Object.defineProperty(exports, name, {
        enumerable: true,
        get: getter
      });
    }
  };
  __webpack_require__.r = function(exports) {
    if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
      Object.defineProperty(exports, Symbol.toStringTag, {
        value: "Module"
      });
    }
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
  };
  __webpack_require__.t = function(value, mode) {
    if (mode & 1) value = __webpack_require__(value);
    if (mode & 8) return value;
    if (mode & 4 && typeof value === "object" && value && value.__esModule) return value;
    var ns = Object.create(null);
    __webpack_require__.r(ns);
    Object.defineProperty(ns, "default", {
      enumerable: true,
      value: value
    });
    if (mode & 2 && typeof value != "string") for (var key in value) __webpack_require__.d(ns, key, function(key) {
      return value[key];
    }.bind(null, key));
    return ns;
  };
  __webpack_require__.n = function(module) {
    var getter = module && module.__esModule ? function getDefault() {
      return module["default"];
    } : function getModuleExports() {
      return module;
    };
    __webpack_require__.d(getter, "a", getter);
    return getter;
  };
  __webpack_require__.o = function(object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };
  __webpack_require__.p = "";
  return __webpack_require__(__webpack_require__.s = 5);
})([ function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  function throttle(delay, noTrailing, callback, debounceMode) {
    var timeoutID;
    var cancelled = false;
    var lastExec = 0;
    function clearExistingTimeout() {
      if (timeoutID) {
        clearTimeout(timeoutID);
      }
    }
    function cancel() {
      clearExistingTimeout();
      cancelled = true;
    }
    if (typeof noTrailing !== "boolean") {
      debounceMode = callback;
      callback = noTrailing;
      noTrailing = undefined;
    }
    function wrapper() {
      var self = this;
      var elapsed = Date.now() - lastExec;
      var args = arguments;
      if (cancelled) {
        return;
      }
      function exec() {
        lastExec = Date.now();
        callback.apply(self, args);
      }
      function clear() {
        timeoutID = undefined;
      }
      if (debounceMode && !timeoutID) {
        exec();
      }
      clearExistingTimeout();
      if (debounceMode === undefined && elapsed > delay) {
        exec();
      } else if (noTrailing !== true) {
        timeoutID = setTimeout(debounceMode ? clear : exec, debounceMode === undefined ? delay - elapsed : delay);
      }
    }
    wrapper.cancel = cancel;
    return wrapper;
  }
  function debounce(delay, atBegin, callback) {
    return callback === undefined ? throttle(delay, atBegin, false) : throttle(delay, callback, atBegin !== false);
  }
  const isExtensionContext = typeof chrome === "object" && chrome && typeof chrome.runtime === "object";
  const isWeb = location.protocol.startsWith("http");
  function isContentScript() {
    return isExtensionContext && isWeb;
  }
  function isBackgroundPage() {
    return isExtensionContext && !isWeb && location.pathname === "/_generated_background_page.html";
  }
  function isOptionsPage() {
    if (!isExtensionContext || !chrome.runtime.getManifest) {
      return false;
    }
    const {options_ui: options_ui} = chrome.runtime.getManifest();
    if (typeof options_ui !== "object" || typeof options_ui.page !== "string") {
      return false;
    }
    const url = new URL(options_ui.page, location.origin);
    return url.pathname === location.pathname && url.origin === location.origin;
  }
  var matches_selector = __webpack_require__(2);
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  var asyncGenerator = function() {
    function AwaitValue(value) {
      this.value = value;
    }
    function AsyncGenerator(gen) {
      var front, back;
      function send(key, arg) {
        return new Promise(function(resolve, reject) {
          var request = {
            key: key,
            arg: arg,
            resolve: resolve,
            reject: reject,
            next: null
          };
          if (back) {
            back = back.next = request;
          } else {
            front = back = request;
            resume(key, arg);
          }
        });
      }
      function resume(key, arg) {
        try {
          var result = gen[key](arg);
          var value = result.value;
          if (value instanceof AwaitValue) {
            Promise.resolve(value.value).then(function(arg) {
              resume("next", arg);
            }, function(arg) {
              resume("throw", arg);
            });
          } else {
            settle(result.done ? "return" : "normal", result.value);
          }
        } catch (err) {
          settle("throw", err);
        }
      }
      function settle(type, value) {
        switch (type) {
         case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

         case "throw":
          front.reject(value);
          break;

         default:
          front.resolve({
            value: value,
            done: false
          });
          break;
        }
        front = front.next;
        if (front) {
          resume(front.key, front.arg);
        } else {
          back = null;
        }
      }
      this._invoke = send;
      if (typeof gen.return !== "function") {
        this.return = undefined;
      }
    }
    if (typeof Symbol === "function" && Symbol.asyncIterator) {
      AsyncGenerator.prototype[Symbol.asyncIterator] = function() {
        return this;
      };
    }
    AsyncGenerator.prototype.next = function(arg) {
      return this._invoke("next", arg);
    };
    AsyncGenerator.prototype.throw = function(arg) {
      return this._invoke("throw", arg);
    };
    AsyncGenerator.prototype.return = function(arg) {
      return this._invoke("return", arg);
    };
    return {
      wrap: function(fn) {
        return function() {
          return new AsyncGenerator(fn.apply(this, arguments));
        };
      },
      await: function(value) {
        return new AwaitValue(value);
      }
    };
  }();
  var classCallCheck = function(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };
  var createClass = function() {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function(Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();
  var inherits = function(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };
  var possibleConstructorReturn = function(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };
  var TypeRegistry = function() {
    function TypeRegistry() {
      var initial = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      classCallCheck(this, TypeRegistry);
      this.registeredTypes = initial;
    }
    createClass(TypeRegistry, [ {
      key: "get",
      value: function get(type) {
        if (typeof this.registeredTypes[type] !== "undefined") {
          return this.registeredTypes[type];
        } else {
          return this.registeredTypes["default"];
        }
      }
    }, {
      key: "register",
      value: function register(type, item) {
        if (typeof this.registeredTypes[type] === "undefined") {
          this.registeredTypes[type] = item;
        }
      }
    }, {
      key: "registerDefault",
      value: function registerDefault(item) {
        this.register("default", item);
      }
    } ]);
    return TypeRegistry;
  }();
  var KeyExtractors = function(_TypeRegistry) {
    inherits(KeyExtractors, _TypeRegistry);
    function KeyExtractors(options) {
      classCallCheck(this, KeyExtractors);
      var _this = possibleConstructorReturn(this, (KeyExtractors.__proto__ || Object.getPrototypeOf(KeyExtractors)).call(this, options));
      _this.registerDefault(function(el) {
        return el.getAttribute("name") || "";
      });
      return _this;
    }
    return KeyExtractors;
  }(TypeRegistry);
  var InputReaders = function(_TypeRegistry) {
    inherits(InputReaders, _TypeRegistry);
    function InputReaders(options) {
      classCallCheck(this, InputReaders);
      var _this = possibleConstructorReturn(this, (InputReaders.__proto__ || Object.getPrototypeOf(InputReaders)).call(this, options));
      _this.registerDefault(function(el) {
        return el.value;
      });
      _this.register("checkbox", function(el) {
        return el.getAttribute("value") !== null ? el.checked ? el.getAttribute("value") : null : el.checked;
      });
      _this.register("select", function(el) {
        return getSelectValue(el);
      });
      return _this;
    }
    return InputReaders;
  }(TypeRegistry);
  function getSelectValue(elem) {
    var value, option, i;
    var options = elem.options;
    var index = elem.selectedIndex;
    var one = elem.type === "select-one";
    var values = one ? null : [];
    var max = one ? index + 1 : options.length;
    if (index < 0) {
      i = max;
    } else {
      i = one ? index : 0;
    }
    for (;i < max; i++) {
      option = options[i];
      if ((option.selected || i === index) && !option.disabled && (!option.parentNode.disabled || option.parentNode.tagName.toLowerCase() === "optgroup")) {
        value = option.value;
        if (one) {
          return value;
        }
        values.push(value);
      }
    }
    return values;
  }
  var KeyAssignmentValidators = function(_TypeRegistry) {
    inherits(KeyAssignmentValidators, _TypeRegistry);
    function KeyAssignmentValidators(options) {
      classCallCheck(this, KeyAssignmentValidators);
      var _this = possibleConstructorReturn(this, (KeyAssignmentValidators.__proto__ || Object.getPrototypeOf(KeyAssignmentValidators)).call(this, options));
      _this.registerDefault(function() {
        return true;
      });
      _this.register("radio", function(el) {
        return el.checked;
      });
      return _this;
    }
    return KeyAssignmentValidators;
  }(TypeRegistry);
  function keySplitter(key) {
    var matches = key.match(/[^[\]]+/g);
    var lastKey = void 0;
    if (key.length > 1 && key.indexOf("[]") === key.length - 2) {
      lastKey = matches.pop();
      matches.push([ lastKey ]);
    }
    return matches;
  }
  function getElementType(el) {
    var typeAttr = void 0;
    var tagName = el.tagName;
    var type = tagName;
    if (tagName.toLowerCase() === "input") {
      typeAttr = el.getAttribute("type");
      if (typeAttr) {
        type = typeAttr;
      } else {
        type = "text";
      }
    }
    return type.toLowerCase();
  }
  function getInputElements(element, options) {
    return Array.prototype.filter.call(element.querySelectorAll("input,select,textarea"), function(el) {
      if (el.tagName.toLowerCase() === "input" && (el.type === "submit" || el.type === "reset")) {
        return false;
      }
      var myType = getElementType(el);
      var extractor = options.keyExtractors.get(myType);
      var identifier = extractor(el);
      var foundInInclude = (options.include || []).indexOf(identifier) !== -1;
      var foundInExclude = (options.exclude || []).indexOf(identifier) !== -1;
      var foundInIgnored = false;
      var reject = false;
      if (options.ignoredTypes) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;
        try {
          for (var _iterator = options.ignoredTypes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var selector = _step.value;
            if (matches_selector(el, selector)) {
              foundInIgnored = true;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
      if (foundInInclude) {
        reject = false;
      } else {
        if (options.include) {
          reject = true;
        } else {
          reject = foundInExclude || foundInIgnored;
        }
      }
      return !reject;
    });
  }
  function assignKeyValue(obj, keychain, value) {
    if (!keychain) {
      return obj;
    }
    var key = keychain.shift();
    if (!obj[key]) {
      obj[key] = Array.isArray(key) ? [] : {};
    }
    if (keychain.length === 0) {
      if (!Array.isArray(obj[key])) {
        obj[key] = value;
      } else if (value !== null) {
        obj[key].push(value);
      }
    }
    if (keychain.length > 0) {
      assignKeyValue(obj[key], keychain, value);
    }
    return obj;
  }
  function serialize(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var data = {};
    options.keySplitter = options.keySplitter || keySplitter;
    options.keyExtractors = new KeyExtractors(options.keyExtractors || {});
    options.inputReaders = new InputReaders(options.inputReaders || {});
    options.keyAssignmentValidators = new KeyAssignmentValidators(options.keyAssignmentValidators || {});
    Array.prototype.forEach.call(getInputElements(element, options), function(el) {
      var type = getElementType(el);
      var keyExtractor = options.keyExtractors.get(type);
      var key = keyExtractor(el);
      var inputReader = options.inputReaders.get(type);
      var value = inputReader(el);
      var validKeyAssignment = options.keyAssignmentValidators.get(type);
      if (validKeyAssignment(el, key, value)) {
        var keychain = options.keySplitter(key);
        data = assignKeyValue(data, keychain, value);
      }
    });
    return data;
  }
  var InputWriters = function(_TypeRegistry) {
    inherits(InputWriters, _TypeRegistry);
    function InputWriters(options) {
      classCallCheck(this, InputWriters);
      var _this = possibleConstructorReturn(this, (InputWriters.__proto__ || Object.getPrototypeOf(InputWriters)).call(this, options));
      _this.registerDefault(function(el, value) {
        el.value = value;
      });
      _this.register("checkbox", function(el, value) {
        if (value === null) {
          el.indeterminate = true;
        } else {
          el.checked = Array.isArray(value) ? value.indexOf(el.value) !== -1 : value;
        }
      });
      _this.register("radio", function(el, value) {
        if (value !== undefined) {
          el.checked = el.value === value.toString();
        }
      });
      _this.register("select", setSelectValue);
      return _this;
    }
    return InputWriters;
  }(TypeRegistry);
  function makeArray(arr) {
    var ret = [];
    if (arr !== null) {
      if (Array.isArray(arr)) {
        ret.push.apply(ret, arr);
      } else {
        ret.push(arr);
      }
    }
    return ret;
  }
  function setSelectValue(elem, value) {
    var optionSet, option;
    var options = elem.options;
    var values = makeArray(value);
    var i = options.length;
    while (i--) {
      option = options[i];
      if (values.indexOf(option.value) > -1) {
        option.setAttribute("selected", true);
        optionSet = true;
      }
    }
    if (!optionSet) {
      elem.selectedIndex = -1;
    }
  }
  function keyJoiner(parentKey, childKey) {
    return parentKey + "[" + childKey + "]";
  }
  function flattenData(data, parentKey) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var flatData = {};
    var keyJoiner$$ = options.keyJoiner || keyJoiner;
    for (var keyName in data) {
      if (!data.hasOwnProperty(keyName)) {
        continue;
      }
      var value = data[keyName];
      var hash = {};
      if (parentKey) {
        keyName = keyJoiner$$(parentKey, keyName);
      }
      if (Array.isArray(value)) {
        hash[keyName + "[]"] = value;
        hash[keyName] = value;
      } else if ((typeof value === "undefined" ? "undefined" : _typeof(value)) === "object") {
        hash = flattenData(value, keyName, options);
      } else {
        hash[keyName] = value;
      }
      Object.assign(flatData, hash);
    }
    return flatData;
  }
  function deserialize(form, data) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var flattenedData = flattenData(data, null, options);
    options.keyExtractors = new KeyExtractors(options.keyExtractors || {});
    options.inputWriters = new InputWriters(options.inputWriters || {});
    Array.prototype.forEach.call(getInputElements(form, options), function(el) {
      var type = getElementType(el);
      var keyExtractor = options.keyExtractors.get(type);
      var key = keyExtractor(el);
      var inputWriter = options.inputWriters.get(type);
      var value = flattenedData[key];
      inputWriter(el, value);
    });
  }
  class webext_options_sync_OptionsSync {
    constructor({defaults: defaults = {}, storageName: storageName = "options", migrations: migrations = [], logging: logging = true} = {}) {
      this.storageName = storageName;
      this.defaults = defaults;
      this._handleFormInput = debounce(600, this._handleFormInput.bind(this));
      this._handleStorageChangeOnForm = this._handleStorageChangeOnForm.bind(this);
      if (logging === false) {
        this._log = () => {};
      }
      if (isBackgroundPage()) {
        chrome.management.getSelf(({installType: installType}) => {
          if (installType === "development") {
            this._runMigrations(migrations);
          } else {
            chrome.runtime.onInstalled.addListener(() => {
              this._runMigrations(migrations);
            });
          }
        });
      }
    }
    async getAll() {
      return new Promise((resolve, reject) => {
        chrome.storage.sync.get(this.storageName, result => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError);
          } else {
            resolve(this._includeDefaults(result[this.storageName]));
          }
        });
      });
    }
    async setAll(newOptions) {
      const thinnedOptions = this._excludeDefaults(newOptions);
      this._log("log", "Saving options", newOptions);
      this._log("log", "Without the default values", thinnedOptions);
      return new Promise((resolve, reject) => {
        chrome.storage.sync.set({
          [this.storageName]: thinnedOptions
        }, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError);
          } else {
            resolve();
          }
        });
      });
    }
    async set(newOptions) {
      return this.setAll({
        ...await this.getAll(),
        ...newOptions
      });
    }
    async syncForm(form) {
      this._form = form instanceof HTMLFormElement ? form : document.querySelector(form);
      this._form.addEventListener("input", this._handleFormInput);
      chrome.storage.onChanged.addListener(this._handleStorageChangeOnForm);
      this._updateForm(this._form, await this.getAll());
    }
    async stopSyncForm() {
      if (this._form) {
        this._form.removeEventListener("input", this._handleFormInput);
        chrome.storage.onChanged.removeListener(this._handleStorageChangeOnForm);
        delete this._form;
      }
    }
    _log(method, ...args) {
      console[method](...args);
    }
    _includeDefaults(options) {
      return {
        ...this.defaults,
        ...options
      };
    }
    _excludeDefaults(options) {
      const thinnedOptions = {
        ...options
      };
      for (const [key, value] of Object.entries(thinnedOptions)) {
        if (this.defaults[key] === value) {
          delete thinnedOptions[key];
        }
      }
      return thinnedOptions;
    }
    async _runMigrations(migrations) {
      const options = await this.getAll();
      if (migrations && migrations.length > 0) {
        this._log("log", "Found these stored options", {
          ...options
        });
        this._log("info", "Will run", migrations.length, migrations.length === 1 ? "migration" : " migrations");
        migrations.forEach(migrate => migrate(options, this.defaults));
      }
      this.setAll(options);
    }
    async _handleFormInput({target: target}) {
      const form = target.form;
      await this.set(this._parseForm(form));
      form.dispatchEvent(new CustomEvent("options-sync:form-synced", {
        bubbles: true
      }));
    }
    _updateForm(form, options) {
      const currentFormState = this._parseForm(form);
      for (const [key, value] of Object.entries(options)) {
        if (currentFormState[key] === value) {
          delete options[key];
        }
      }
      const include = Object.keys(options);
      if (include.length > 0) {
        deserialize(form, options, {
          include: include
        });
      }
    }
    _parseForm(form) {
      const include = [];
      for (const field of form.querySelectorAll("[name]")) {
        if (field.validity.valid && !field.disabled) {
          include.push(field.name.replace(/\[.*\]/, ""));
        }
      }
      return serialize(form, {
        include: include
      });
    }
    _handleStorageChangeOnForm(changes, areaName) {
      if (areaName === "sync" && changes[this.storageName] && (!document.hasFocus() || !this._form.contains(document.activeElement))) {
        this._updateForm(this._form, this._includeDefaults(changes[this.storageName].newValue));
      }
    }
  }
  webext_options_sync_OptionsSync.migrations = {
    removeUnused(options, defaults) {
      for (const key of Object.keys(options)) {
        if (!(key in defaults)) {
          delete options[key];
        }
      }
    }
  };
  var webext_options_sync = webext_options_sync_OptionsSync;
  const optionsStorage = new webext_options_sync({
    defaults: {
      token: "",
      rootUrl: "https://api.github.com/",
      playNotifSound: false,
      showDesktopNotif: false,
      onlyParticipating: false,
      reuseTabs: false,
      updateCountOnNavigation: false
    },
    migrations: [ webext_options_sync.migrations.removeUnused ]
  });
  var options_storage = __webpack_exports__["a"] = optionsStorage;
}, function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  __webpack_require__.d(__webpack_exports__, "a", function() {
    return queryPermission;
  });
  __webpack_require__.d(__webpack_exports__, "b", function() {
    return requestPermission;
  });
  async function queryPermission(permission) {
    try {
      return browser.permissions.contains({
        permissions: [ permission ]
      });
    } catch (error) {
      console.log(error);
      return false;
    }
  }
  async function requestPermission(permission) {
    try {
      return browser.permissions.request({
        permissions: [ permission ]
      });
    } catch (error) {
      console.log(error);
      return false;
    }
  }
}, function(module, exports, __webpack_require__) {
  "use strict";
  var proto = typeof Element !== "undefined" ? Element.prototype : {};
  var vendor = proto.matches || proto.matchesSelector || proto.webkitMatchesSelector || proto.mozMatchesSelector || proto.msMatchesSelector || proto.oMatchesSelector;
  module.exports = match;
  function match(el, selector) {
    if (!el || el.nodeType !== 1) return false;
    if (vendor) return vendor.call(el, selector);
    var nodes = el.parentNode.querySelectorAll(selector);
    for (var i = 0; i < nodes.length; i++) {
      if (nodes[i] == el) return true;
    }
    return false;
  }
}, function(module, exports, __webpack_require__) {
  "use strict";
  const createAbortError = () => {
    const error = new Error("Delay aborted");
    error.name = "AbortError";
    return error;
  };
  const createDelay = ({clearTimeout: defaultClear, setTimeout: set, willResolve: willResolve}) => (ms, {value: value, signal: signal} = {}) => {
    if (signal && signal.aborted) {
      return Promise.reject(createAbortError());
    }
    let timeoutId;
    let settle;
    let rejectFn;
    const clear = defaultClear || clearTimeout;
    const signalListener = () => {
      clear(timeoutId);
      rejectFn(createAbortError());
    };
    const cleanup = () => {
      if (signal) {
        signal.removeEventListener("abort", signalListener);
      }
    };
    const delayPromise = new Promise((resolve, reject) => {
      settle = () => {
        cleanup();
        if (willResolve) {
          resolve(value);
        } else {
          reject(value);
        }
      };
      rejectFn = reject;
      timeoutId = (set || setTimeout)(settle, ms);
    });
    if (signal) {
      signal.addEventListener("abort", signalListener, {
        once: true
      });
    }
    delayPromise.clear = () => {
      clear(timeoutId);
      timeoutId = null;
      cleanup();
      settle();
    };
    return delayPromise;
  };
  const delay = createDelay({
    willResolve: true
  });
  delay.reject = createDelay({
    willResolve: false
  });
  delay.createWithTimers = ({clearTimeout: clearTimeout, setTimeout: setTimeout}) => {
    const delay = createDelay({
      clearTimeout: clearTimeout,
      setTimeout: setTimeout,
      willResolve: true
    });
    delay.reject = createDelay({
      clearTimeout: clearTimeout,
      setTimeout: setTimeout,
      willResolve: false
    });
    return delay;
  };
  module.exports = delay;
  module.exports.default = delay;
}, , function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  __webpack_require__.r(__webpack_exports__);
  var delay = __webpack_require__(3);
  var delay_default = __webpack_require__.n(delay);
  var options_storage = __webpack_require__(0);
  var local_store = {
    async get(key) {
      const result = await browser.storage.local.get(key);
      return result[key];
    },
    async set(key, value) {
      return browser.storage.local.set({
        [key]: value
      });
    },
    async remove(key) {
      return browser.storage.local.remove(key);
    },
    async clear() {
      return browser.storage.local.clear();
    }
  };
  async function getHostname() {
    const {rootUrl: rootUrl} = await options_storage["a"].getAll();
    if (/(^(https:\/\/)?(api\.)?github\.com)/.test(rootUrl)) {
      return "github.com";
    }
    return new URL(rootUrl).hostname;
  }
  async function getTabUrl() {
    const {onlyParticipating: onlyParticipating} = await options_storage["a"].getAll();
    const useParticipating = onlyParticipating ? "/participating" : "";
    return `https://${await getHostname()}/notifications${useParticipating}`;
  }
  async function getApiUrl() {
    const {rootUrl: rootUrl} = await options_storage["a"].getAll();
    if (/(^(https:\/\/)?(api\.)?github\.com)/.test(rootUrl)) {
      return "https://api.github.com";
    }
    return `${rootUrl}api/v3`;
  }
  async function getParsedUrl(endpoint, params) {
    const api = await getApiUrl();
    const query = params ? "?" + new URLSearchParams(params).toString() : "";
    return `${api}${endpoint}${query}`;
  }
  async function getHeaders() {
    const {token: token} = await options_storage["a"].getAll();
    if (!/[a-z\d]{40}/.test(token)) {
      throw new Error("missing token");
    }
    return {
      Authorization: `token ${token}`,
      "If-Modified-Since": ""
    };
  }
  async function makeApiRequest(endpoint, params) {
    const url = await getParsedUrl(endpoint, params);
    let response;
    try {
      response = await fetch(url, {
        headers: await getHeaders()
      });
    } catch (error) {
      console.error(error);
      return Promise.reject(new Error("network error"));
    }
    const {status: status, headers: headers} = response;
    if (status >= 500) {
      return Promise.reject(new Error("server error"));
    }
    if (status >= 400) {
      return Promise.reject(new Error("client error"));
    }
    try {
      const json = await response.json();
      return {
        headers: headers,
        json: json
      };
    } catch (error) {
      return Promise.reject(new Error("parse error"));
    }
  }
  async function getNotificationResponse({maxItems: maxItems = 100, lastModified: lastModified = ""} = {}) {
    const {onlyParticipating: onlyParticipating} = await options_storage["a"].getAll();
    const params = {
      per_page: maxItems
    };
    if (onlyParticipating) {
      params.participating = onlyParticipating;
    }
    if (lastModified) {
      params.since = lastModified;
    }
    return makeApiRequest("/notifications", params);
  }
  async function getNotifications({maxItems: maxItems, lastModified: lastModified} = {}) {
    const {json: notifications} = await getNotificationResponse({
      maxItems: maxItems,
      lastModified: lastModified
    });
    return notifications || [];
  }
  async function getNotificationCount() {
    const {headers: headers, json: notifications} = await getNotificationResponse({
      maxItems: 1
    });
    const interval = Number(headers.get("X-Poll-Interval"));
    const lastModified = new Date(headers.get("Last-Modified")).toISOString();
    const linkHeader = headers.get("Link");
    if (linkHeader === null) {
      return {
        count: notifications.length,
        interval: interval,
        lastModified: lastModified
      };
    }
    const lastlink = linkHeader.split(", ").find(link => {
      return link.endsWith('rel="last"');
    });
    const count = Number(lastlink.slice(lastlink.lastIndexOf("page=") + 5, lastlink.lastIndexOf(">")));
    return {
      count: count,
      interval: interval,
      lastModified: lastModified
    };
  }
  function isChrome() {
    return navigator.userAgent.includes("Chrome");
  }
  async function isNotificationTargetPage(url) {
    const urlObject = new URL(url);
    if (urlObject.hostname !== await getHostname()) {
      return false;
    }
    const pathname = urlObject.pathname.replace(/^[/]|[/]$/g, "");
    if (pathname === "notifications") {
      return true;
    }
    const repoPath = pathname.split("/").slice(2).join("/");
    return /^(((issues|pull)\/\d+(\/(commits|files))?)|(commit\/.*)|(notifications$))/.test(repoPath);
  }
  const emptyTabUrls = isChrome() ? [ "chrome://newtab/", "chrome-search://local-ntp/local-ntp.html" ] : [];
  async function createTab(url) {
    return browser.tabs.create({
      url: url
    });
  }
  async function updateTab(tabId, options) {
    return browser.tabs.update(tabId, options);
  }
  async function queryTabs(urlList) {
    const currentWindow = true;
    return browser.tabs.query({
      currentWindow: currentWindow,
      url: urlList
    });
  }
  async function openTab(url) {
    const {reuseTabs: reuseTabs} = await options_storage["a"].getAll();
    if (reuseTabs) {
      const matchingUrls = [ url ];
      if (url.endsWith("/notifications")) {
        matchingUrls.push(url + "?all=1");
      }
      const existingTabs = await queryTabs(matchingUrls);
      if (existingTabs && existingTabs.length > 0) {
        return updateTab(existingTabs[0].id, {
          url: url,
          active: true
        });
      }
      const emptyTabs = await queryTabs(emptyTabUrls);
      if (emptyTabs && emptyTabs.length > 0) {
        return updateTab(emptyTabs[0].id, {
          url: url,
          active: true
        });
      }
    }
    return createTab(url);
  }
  var permissions_service = __webpack_require__(1);
  const notificationReasons = new Map([ [ "subscribed", "You are watching the repository" ], [ "manual", "You are subscribed to this thread" ], [ "author", "You created this thread" ], [ "comment", "You commented on this thread" ], [ "mention", "New updates from thread" ], [ "team_mention", "New updates from thread" ], [ "state_change", "Thread status changed" ], [ "assign", "You were assigned to the thread" ], [ "security_alert", "New security vulnerability found" ], [ "invitation", "You accepted an invitation" ], [ "review_requested", "PR Review Requested" ] ]);
  const errorTitles = new Map([ [ "missing token", "Missing access token, please create one and enter it in Options" ], [ "server error", "GitHub having issues serving requests" ], [ "client error", "Invalid token, enter a valid one" ], [ "network error", "You have to be connected to the Internet" ], [ "parse error", "Unable to handle server response" ], [ "default", "Unknown error" ] ]);
  const errorSymbols = new Map([ [ "missing token", "X" ], [ "client error", "!" ], [ "default", "?" ] ]);
  const warningTitles = new Map([ [ "default", "Unknown warning" ], [ "offline", "No Internet connnection" ] ]);
  const warningSymbols = new Map([ [ "default", "warn" ], [ "offline", "off" ] ]);
  const colors = new Map([ [ "default", [ 3, 102, 214, 255 ] ], [ "error", [ 203, 36, 49, 255 ] ], [ "warning", [ 245, 159, 0, 255 ] ] ]);
  function getBadgeDefaultColor() {
    return colors.get("default");
  }
  function getBadgeErrorColor() {
    return colors.get("error");
  }
  function getBadgeWarningColor() {
    return colors.get("warning");
  }
  function getWarningTitle(warning) {
    return warningTitles.get(warning) || warningTitles.get("default");
  }
  function getWarningSymbol(warning) {
    return warningSymbols.get(warning) || warningSymbols.get("default");
  }
  function getErrorTitle(error) {
    return errorTitles.get(error.message) || errorTitles.get("default");
  }
  function getErrorSymbol(error) {
    return errorSymbols.get(error.message) || errorSymbols.get("default");
  }
  function getNotificationReasonText(reason) {
    return notificationReasons.get(reason) || "";
  }
  const defaultTitle = "Notifier for GitHub";
  function render(text, color, title) {
    browser.browserAction.setBadgeText({
      text: text
    });
    browser.browserAction.setBadgeBackgroundColor({
      color: color
    });
    browser.browserAction.setTitle({
      title: title
    });
  }
  function getCountString(count) {
    if (count === 0) {
      return "";
    }
    if (count > 9999) {
      return "∞";
    }
    return String(count);
  }
  function getErrorData(error) {
    const title = getErrorTitle(error);
    const symbol = getErrorSymbol(error);
    return {
      symbol: symbol,
      title: title
    };
  }
  function renderCount(count) {
    const color = getBadgeDefaultColor();
    const title = defaultTitle;
    render(getCountString(count), color, title);
  }
  function renderError(error) {
    const color = getBadgeErrorColor();
    const {symbol: symbol, title: title} = getErrorData(error);
    render(symbol, color, title);
  }
  function renderWarning(warning) {
    const color = getBadgeWarningColor();
    const title = getWarningTitle(warning);
    const symbol = getWarningSymbol(warning);
    render(symbol, color, title);
  }
  function getLastReadForNotification(notification) {
    const lastReadTime = notification.last_read_at;
    const lastRead = new Date(lastReadTime || notification.updated_at);
    if (lastReadTime) {
      lastRead.setSeconds(lastRead.getSeconds() + 1);
    }
    return lastRead.toISOString();
  }
  async function issueOrPRHandler(notification) {
    const notificationUrl = notification.subject.url;
    try {
      const url = new URL(notificationUrl);
      const lastRead = getLastReadForNotification(notification);
      try {
        const {json: comments} = await makeApiRequest(`${url.pathname}/comments`, {
          since: lastRead,
          per_page: 1
        });
        const comment = comments[0];
        if (comment) {
          return comment.html_url;
        }
        const {json: response} = await makeApiRequest(url.pathname);
        const targetUrl = response.message === "Not Found" ? await getTabUrl() : response.html_url;
        return targetUrl;
      } catch (error) {
        url.hostname = await getHostname();
        url.pathname = url.pathname.replace("/api/v3", "");
        url.pathname = url.pathname.replace("/repos", "");
        url.pathname = url.pathname.replace("/pulls/", "/pull/");
        return url.href;
      }
    } catch (error) {
      throw error;
    }
  }
  const notificationHandlers = {
    Issue: issueOrPRHandler,
    PullRequest: issueOrPRHandler,
    RepositoryInvitation: notification => {
      return `${notification.repository.html_url}/invitations`;
    }
  };
  async function closeNotification(notificationId) {
    return browser.notifications.clear(notificationId);
  }
  async function openNotification(notificationId) {
    const notification = await local_store.get(notificationId);
    await closeNotification(notificationId);
    await removeNotification(notificationId);
    try {
      const urlToOpen = await notificationHandlers[notification.subject.type](notification);
      return openTab(urlToOpen);
    } catch (error) {
      return openTab(await getTabUrl());
    }
  }
  async function removeNotification(notificationId) {
    return local_store.remove(notificationId);
  }
  function getNotificationObject(notificationInfo) {
    return {
      title: notificationInfo.subject.title,
      iconUrl: "icon-notif.png",
      type: "basic",
      message: notificationInfo.repository.full_name,
      contextMessage: getNotificationReasonText(notificationInfo.reason)
    };
  }
  async function showNotifications(notifications) {
    for (const notification of notifications) {
      const notificationId = `github-notifier-${notification.id}`;
      const notificationObject = getNotificationObject(notification);
      await browser.notifications.create(notificationId, notificationObject);
      await local_store.set(notificationId, notification);
      await delay_default()(50);
    }
  }
  async function playNotificationSound() {
    const audio = new Audio();
    audio.src = await browser.extension.getURL("/sounds/bell.ogg");
    audio.play();
  }
  async function checkNotifications(lastModified) {
    const notifications = await getNotifications({
      lastModified: lastModified
    });
    const {showDesktopNotif: showDesktopNotif, playNotifSound: playNotifSound} = await options_storage["a"].getAll();
    if (playNotifSound && notifications.length > 1) {
      await playNotificationSound();
    }
    if (showDesktopNotif) {
      await showNotifications(notifications);
    }
  }
  async function scheduleNextAlarm(interval) {
    const intervalSetting = await local_store.get("interval") || 60;
    const intervalValue = interval || 60;
    if (intervalSetting !== intervalValue) {
      local_store.set("interval", intervalValue);
    }
    const delayInMinutes = Math.max(Math.ceil(intervalValue / 60), 1);
    browser.alarms.create({
      delayInMinutes: delayInMinutes
    });
  }
  async function handleLastModified(newLastModified) {
    const lastModified = await local_store.get("lastModified") || new Date(0);
    if (newLastModified !== lastModified) {
      const {showDesktopNotif: showDesktopNotif, playNotifSound: playNotifSound} = await options_storage["a"].getAll();
      if (showDesktopNotif === true || playNotifSound === true) {
        await checkNotifications(lastModified);
      }
      await local_store.set("lastModified", newLastModified);
    }
  }
  async function updateNotificationCount() {
    const response = await getNotificationCount();
    const {count: count, interval: interval, lastModified: lastModified} = response;
    renderCount(count);
    scheduleNextAlarm(interval);
    handleLastModified(lastModified);
  }
  function handleError(error) {
    scheduleNextAlarm();
    renderError(error);
  }
  function handleOfflineStatus() {
    renderWarning("offline");
    scheduleNextAlarm();
  }
  async function update() {
    if (navigator.onLine) {
      try {
        await updateNotificationCount();
      } catch (error) {
        handleError(error);
      }
    } else {
      handleOfflineStatus();
    }
  }
  async function handleBrowserActionClick() {
    await openTab(await getTabUrl());
  }
  function handleInstalled(details) {
    if (details.reason === "install") {
      browser.runtime.openOptionsPage();
    }
  }
  function handleConnectionStatus() {
    if (navigator.onLine) {
      update();
    } else {
      handleOfflineStatus();
    }
  }
  async function onMessage(message) {
    if (message === "update") {
      await addHandlers();
      await update();
    }
  }
  async function onTabUpdated(tabId, changeInfo, tab) {
    if (changeInfo.status !== "complete") {
      return;
    }
    if (await isNotificationTargetPage(tab.url)) {
      await delay_default()(1e3);
      await update();
    }
  }
  async function addHandlers() {
    const {updateCountOnNavigation: updateCountOnNavigation} = await options_storage["a"].getAll();
    if (await Object(permissions_service["a"])("notifications")) {
      browser.notifications.onClicked.addListener(id => {
        openNotification(id);
      });
    }
    if (await Object(permissions_service["a"])("tabs")) {
      if (updateCountOnNavigation) {
        browser.tabs.onUpdated.addListener(onTabUpdated);
      } else {
        browser.tabs.onUpdated.removeListener(onTabUpdated);
      }
    }
  }
  function init() {
    window.addEventListener("online", handleConnectionStatus);
    window.addEventListener("offline", handleConnectionStatus);
    browser.alarms.onAlarm.addListener(update);
    browser.alarms.create({
      when: Date.now() + 2e3
    });
    browser.runtime.onMessage.addListener(onMessage);
    browser.runtime.onInstalled.addListener(handleInstalled);
    if (isChrome()) {
      browser.permissions.onAdded.addListener(addHandlers);
    }
    browser.browserAction.onClicked.addListener(handleBrowserActionClick);
    addHandlers();
    update();
  }
  init();
} ]);