(function(modules) {
  var installedModules = {};
  function __webpack_require__(moduleId) {
    if (installedModules[moduleId]) {
      return installedModules[moduleId].exports;
    }
    var module = installedModules[moduleId] = {
      i: moduleId,
      l: false,
      exports: {}
    };
    modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
    module.l = true;
    return module.exports;
  }
  __webpack_require__.m = modules;
  __webpack_require__.c = installedModules;
  __webpack_require__.d = function(exports, name, getter) {
    if (!__webpack_require__.o(exports, name)) {
      Object.defineProperty(exports, name, {
        enumerable: true,
        get: getter
      });
    }
  };
  __webpack_require__.r = function(exports) {
    if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
      Object.defineProperty(exports, Symbol.toStringTag, {
        value: "Module"
      });
    }
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
  };
  __webpack_require__.t = function(value, mode) {
    if (mode & 1) value = __webpack_require__(value);
    if (mode & 8) return value;
    if (mode & 4 && typeof value === "object" && value && value.__esModule) return value;
    var ns = Object.create(null);
    __webpack_require__.r(ns);
    Object.defineProperty(ns, "default", {
      enumerable: true,
      value: value
    });
    if (mode & 2 && typeof value != "string") for (var key in value) __webpack_require__.d(ns, key, function(key) {
      return value[key];
    }.bind(null, key));
    return ns;
  };
  __webpack_require__.n = function(module) {
    var getter = module && module.__esModule ? function getDefault() {
      return module["default"];
    } : function getModuleExports() {
      return module;
    };
    __webpack_require__.d(getter, "a", getter);
    return getter;
  };
  __webpack_require__.o = function(object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };
  __webpack_require__.p = "";
  return __webpack_require__(__webpack_require__.s = 4);
})([ function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  function throttle(delay, noTrailing, callback, debounceMode) {
    var timeoutID;
    var cancelled = false;
    var lastExec = 0;
    function clearExistingTimeout() {
      if (timeoutID) {
        clearTimeout(timeoutID);
      }
    }
    function cancel() {
      clearExistingTimeout();
      cancelled = true;
    }
    if (typeof noTrailing !== "boolean") {
      debounceMode = callback;
      callback = noTrailing;
      noTrailing = undefined;
    }
    function wrapper() {
      var self = this;
      var elapsed = Date.now() - lastExec;
      var args = arguments;
      if (cancelled) {
        return;
      }
      function exec() {
        lastExec = Date.now();
        callback.apply(self, args);
      }
      function clear() {
        timeoutID = undefined;
      }
      if (debounceMode && !timeoutID) {
        exec();
      }
      clearExistingTimeout();
      if (debounceMode === undefined && elapsed > delay) {
        exec();
      } else if (noTrailing !== true) {
        timeoutID = setTimeout(debounceMode ? clear : exec, debounceMode === undefined ? delay - elapsed : delay);
      }
    }
    wrapper.cancel = cancel;
    return wrapper;
  }
  function debounce(delay, atBegin, callback) {
    return callback === undefined ? throttle(delay, atBegin, false) : throttle(delay, callback, atBegin !== false);
  }
  const isExtensionContext = typeof chrome === "object" && chrome && typeof chrome.runtime === "object";
  const isWeb = location.protocol.startsWith("http");
  function isContentScript() {
    return isExtensionContext && isWeb;
  }
  function isBackgroundPage() {
    return isExtensionContext && !isWeb && location.pathname === "/_generated_background_page.html";
  }
  function isOptionsPage() {
    if (!isExtensionContext || !chrome.runtime.getManifest) {
      return false;
    }
    const {options_ui: options_ui} = chrome.runtime.getManifest();
    if (typeof options_ui !== "object" || typeof options_ui.page !== "string") {
      return false;
    }
    const url = new URL(options_ui.page, location.origin);
    return url.pathname === location.pathname && url.origin === location.origin;
  }
  var matches_selector = __webpack_require__(2);
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  var asyncGenerator = function() {
    function AwaitValue(value) {
      this.value = value;
    }
    function AsyncGenerator(gen) {
      var front, back;
      function send(key, arg) {
        return new Promise(function(resolve, reject) {
          var request = {
            key: key,
            arg: arg,
            resolve: resolve,
            reject: reject,
            next: null
          };
          if (back) {
            back = back.next = request;
          } else {
            front = back = request;
            resume(key, arg);
          }
        });
      }
      function resume(key, arg) {
        try {
          var result = gen[key](arg);
          var value = result.value;
          if (value instanceof AwaitValue) {
            Promise.resolve(value.value).then(function(arg) {
              resume("next", arg);
            }, function(arg) {
              resume("throw", arg);
            });
          } else {
            settle(result.done ? "return" : "normal", result.value);
          }
        } catch (err) {
          settle("throw", err);
        }
      }
      function settle(type, value) {
        switch (type) {
         case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

         case "throw":
          front.reject(value);
          break;

         default:
          front.resolve({
            value: value,
            done: false
          });
          break;
        }
        front = front.next;
        if (front) {
          resume(front.key, front.arg);
        } else {
          back = null;
        }
      }
      this._invoke = send;
      if (typeof gen.return !== "function") {
        this.return = undefined;
      }
    }
    if (typeof Symbol === "function" && Symbol.asyncIterator) {
      AsyncGenerator.prototype[Symbol.asyncIterator] = function() {
        return this;
      };
    }
    AsyncGenerator.prototype.next = function(arg) {
      return this._invoke("next", arg);
    };
    AsyncGenerator.prototype.throw = function(arg) {
      return this._invoke("throw", arg);
    };
    AsyncGenerator.prototype.return = function(arg) {
      return this._invoke("return", arg);
    };
    return {
      wrap: function(fn) {
        return function() {
          return new AsyncGenerator(fn.apply(this, arguments));
        };
      },
      await: function(value) {
        return new AwaitValue(value);
      }
    };
  }();
  var classCallCheck = function(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };
  var createClass = function() {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function(Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();
  var inherits = function(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };
  var possibleConstructorReturn = function(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };
  var TypeRegistry = function() {
    function TypeRegistry() {
      var initial = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      classCallCheck(this, TypeRegistry);
      this.registeredTypes = initial;
    }
    createClass(TypeRegistry, [ {
      key: "get",
      value: function get(type) {
        if (typeof this.registeredTypes[type] !== "undefined") {
          return this.registeredTypes[type];
        } else {
          return this.registeredTypes["default"];
        }
      }
    }, {
      key: "register",
      value: function register(type, item) {
        if (typeof this.registeredTypes[type] === "undefined") {
          this.registeredTypes[type] = item;
        }
      }
    }, {
      key: "registerDefault",
      value: function registerDefault(item) {
        this.register("default", item);
      }
    } ]);
    return TypeRegistry;
  }();
  var KeyExtractors = function(_TypeRegistry) {
    inherits(KeyExtractors, _TypeRegistry);
    function KeyExtractors(options) {
      classCallCheck(this, KeyExtractors);
      var _this = possibleConstructorReturn(this, (KeyExtractors.__proto__ || Object.getPrototypeOf(KeyExtractors)).call(this, options));
      _this.registerDefault(function(el) {
        return el.getAttribute("name") || "";
      });
      return _this;
    }
    return KeyExtractors;
  }(TypeRegistry);
  var InputReaders = function(_TypeRegistry) {
    inherits(InputReaders, _TypeRegistry);
    function InputReaders(options) {
      classCallCheck(this, InputReaders);
      var _this = possibleConstructorReturn(this, (InputReaders.__proto__ || Object.getPrototypeOf(InputReaders)).call(this, options));
      _this.registerDefault(function(el) {
        return el.value;
      });
      _this.register("checkbox", function(el) {
        return el.getAttribute("value") !== null ? el.checked ? el.getAttribute("value") : null : el.checked;
      });
      _this.register("select", function(el) {
        return getSelectValue(el);
      });
      return _this;
    }
    return InputReaders;
  }(TypeRegistry);
  function getSelectValue(elem) {
    var value, option, i;
    var options = elem.options;
    var index = elem.selectedIndex;
    var one = elem.type === "select-one";
    var values = one ? null : [];
    var max = one ? index + 1 : options.length;
    if (index < 0) {
      i = max;
    } else {
      i = one ? index : 0;
    }
    for (;i < max; i++) {
      option = options[i];
      if ((option.selected || i === index) && !option.disabled && (!option.parentNode.disabled || option.parentNode.tagName.toLowerCase() === "optgroup")) {
        value = option.value;
        if (one) {
          return value;
        }
        values.push(value);
      }
    }
    return values;
  }
  var KeyAssignmentValidators = function(_TypeRegistry) {
    inherits(KeyAssignmentValidators, _TypeRegistry);
    function KeyAssignmentValidators(options) {
      classCallCheck(this, KeyAssignmentValidators);
      var _this = possibleConstructorReturn(this, (KeyAssignmentValidators.__proto__ || Object.getPrototypeOf(KeyAssignmentValidators)).call(this, options));
      _this.registerDefault(function() {
        return true;
      });
      _this.register("radio", function(el) {
        return el.checked;
      });
      return _this;
    }
    return KeyAssignmentValidators;
  }(TypeRegistry);
  function keySplitter(key) {
    var matches = key.match(/[^[\]]+/g);
    var lastKey = void 0;
    if (key.length > 1 && key.indexOf("[]") === key.length - 2) {
      lastKey = matches.pop();
      matches.push([ lastKey ]);
    }
    return matches;
  }
  function getElementType(el) {
    var typeAttr = void 0;
    var tagName = el.tagName;
    var type = tagName;
    if (tagName.toLowerCase() === "input") {
      typeAttr = el.getAttribute("type");
      if (typeAttr) {
        type = typeAttr;
      } else {
        type = "text";
      }
    }
    return type.toLowerCase();
  }
  function getInputElements(element, options) {
    return Array.prototype.filter.call(element.querySelectorAll("input,select,textarea"), function(el) {
      if (el.tagName.toLowerCase() === "input" && (el.type === "submit" || el.type === "reset")) {
        return false;
      }
      var myType = getElementType(el);
      var extractor = options.keyExtractors.get(myType);
      var identifier = extractor(el);
      var foundInInclude = (options.include || []).indexOf(identifier) !== -1;
      var foundInExclude = (options.exclude || []).indexOf(identifier) !== -1;
      var foundInIgnored = false;
      var reject = false;
      if (options.ignoredTypes) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;
        try {
          for (var _iterator = options.ignoredTypes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var selector = _step.value;
            if (matches_selector(el, selector)) {
              foundInIgnored = true;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
      if (foundInInclude) {
        reject = false;
      } else {
        if (options.include) {
          reject = true;
        } else {
          reject = foundInExclude || foundInIgnored;
        }
      }
      return !reject;
    });
  }
  function assignKeyValue(obj, keychain, value) {
    if (!keychain) {
      return obj;
    }
    var key = keychain.shift();
    if (!obj[key]) {
      obj[key] = Array.isArray(key) ? [] : {};
    }
    if (keychain.length === 0) {
      if (!Array.isArray(obj[key])) {
        obj[key] = value;
      } else if (value !== null) {
        obj[key].push(value);
      }
    }
    if (keychain.length > 0) {
      assignKeyValue(obj[key], keychain, value);
    }
    return obj;
  }
  function serialize(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var data = {};
    options.keySplitter = options.keySplitter || keySplitter;
    options.keyExtractors = new KeyExtractors(options.keyExtractors || {});
    options.inputReaders = new InputReaders(options.inputReaders || {});
    options.keyAssignmentValidators = new KeyAssignmentValidators(options.keyAssignmentValidators || {});
    Array.prototype.forEach.call(getInputElements(element, options), function(el) {
      var type = getElementType(el);
      var keyExtractor = options.keyExtractors.get(type);
      var key = keyExtractor(el);
      var inputReader = options.inputReaders.get(type);
      var value = inputReader(el);
      var validKeyAssignment = options.keyAssignmentValidators.get(type);
      if (validKeyAssignment(el, key, value)) {
        var keychain = options.keySplitter(key);
        data = assignKeyValue(data, keychain, value);
      }
    });
    return data;
  }
  var InputWriters = function(_TypeRegistry) {
    inherits(InputWriters, _TypeRegistry);
    function InputWriters(options) {
      classCallCheck(this, InputWriters);
      var _this = possibleConstructorReturn(this, (InputWriters.__proto__ || Object.getPrototypeOf(InputWriters)).call(this, options));
      _this.registerDefault(function(el, value) {
        el.value = value;
      });
      _this.register("checkbox", function(el, value) {
        if (value === null) {
          el.indeterminate = true;
        } else {
          el.checked = Array.isArray(value) ? value.indexOf(el.value) !== -1 : value;
        }
      });
      _this.register("radio", function(el, value) {
        if (value !== undefined) {
          el.checked = el.value === value.toString();
        }
      });
      _this.register("select", setSelectValue);
      return _this;
    }
    return InputWriters;
  }(TypeRegistry);
  function makeArray(arr) {
    var ret = [];
    if (arr !== null) {
      if (Array.isArray(arr)) {
        ret.push.apply(ret, arr);
      } else {
        ret.push(arr);
      }
    }
    return ret;
  }
  function setSelectValue(elem, value) {
    var optionSet, option;
    var options = elem.options;
    var values = makeArray(value);
    var i = options.length;
    while (i--) {
      option = options[i];
      if (values.indexOf(option.value) > -1) {
        option.setAttribute("selected", true);
        optionSet = true;
      }
    }
    if (!optionSet) {
      elem.selectedIndex = -1;
    }
  }
  function keyJoiner(parentKey, childKey) {
    return parentKey + "[" + childKey + "]";
  }
  function flattenData(data, parentKey) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var flatData = {};
    var keyJoiner$$ = options.keyJoiner || keyJoiner;
    for (var keyName in data) {
      if (!data.hasOwnProperty(keyName)) {
        continue;
      }
      var value = data[keyName];
      var hash = {};
      if (parentKey) {
        keyName = keyJoiner$$(parentKey, keyName);
      }
      if (Array.isArray(value)) {
        hash[keyName + "[]"] = value;
        hash[keyName] = value;
      } else if ((typeof value === "undefined" ? "undefined" : _typeof(value)) === "object") {
        hash = flattenData(value, keyName, options);
      } else {
        hash[keyName] = value;
      }
      Object.assign(flatData, hash);
    }
    return flatData;
  }
  function deserialize(form, data) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var flattenedData = flattenData(data, null, options);
    options.keyExtractors = new KeyExtractors(options.keyExtractors || {});
    options.inputWriters = new InputWriters(options.inputWriters || {});
    Array.prototype.forEach.call(getInputElements(form, options), function(el) {
      var type = getElementType(el);
      var keyExtractor = options.keyExtractors.get(type);
      var key = keyExtractor(el);
      var inputWriter = options.inputWriters.get(type);
      var value = flattenedData[key];
      inputWriter(el, value);
    });
  }
  class webext_options_sync_OptionsSync {
    constructor({defaults: defaults = {}, storageName: storageName = "options", migrations: migrations = [], logging: logging = true} = {}) {
      this.storageName = storageName;
      this.defaults = defaults;
      this._handleFormInput = debounce(600, this._handleFormInput.bind(this));
      this._handleStorageChangeOnForm = this._handleStorageChangeOnForm.bind(this);
      if (logging === false) {
        this._log = () => {};
      }
      if (isBackgroundPage()) {
        chrome.management.getSelf(({installType: installType}) => {
          if (installType === "development") {
            this._runMigrations(migrations);
          } else {
            chrome.runtime.onInstalled.addListener(() => {
              this._runMigrations(migrations);
            });
          }
        });
      }
    }
    async getAll() {
      return new Promise((resolve, reject) => {
        chrome.storage.sync.get(this.storageName, result => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError);
          } else {
            resolve(this._includeDefaults(result[this.storageName]));
          }
        });
      });
    }
    async setAll(newOptions) {
      const thinnedOptions = this._excludeDefaults(newOptions);
      this._log("log", "Saving options", newOptions);
      this._log("log", "Without the default values", thinnedOptions);
      return new Promise((resolve, reject) => {
        chrome.storage.sync.set({
          [this.storageName]: thinnedOptions
        }, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError);
          } else {
            resolve();
          }
        });
      });
    }
    async set(newOptions) {
      return this.setAll({
        ...await this.getAll(),
        ...newOptions
      });
    }
    async syncForm(form) {
      this._form = form instanceof HTMLFormElement ? form : document.querySelector(form);
      this._form.addEventListener("input", this._handleFormInput);
      chrome.storage.onChanged.addListener(this._handleStorageChangeOnForm);
      this._updateForm(this._form, await this.getAll());
    }
    async stopSyncForm() {
      if (this._form) {
        this._form.removeEventListener("input", this._handleFormInput);
        chrome.storage.onChanged.removeListener(this._handleStorageChangeOnForm);
        delete this._form;
      }
    }
    _log(method, ...args) {
      console[method](...args);
    }
    _includeDefaults(options) {
      return {
        ...this.defaults,
        ...options
      };
    }
    _excludeDefaults(options) {
      const thinnedOptions = {
        ...options
      };
      for (const [key, value] of Object.entries(thinnedOptions)) {
        if (this.defaults[key] === value) {
          delete thinnedOptions[key];
        }
      }
      return thinnedOptions;
    }
    async _runMigrations(migrations) {
      const options = await this.getAll();
      if (migrations && migrations.length > 0) {
        this._log("log", "Found these stored options", {
          ...options
        });
        this._log("info", "Will run", migrations.length, migrations.length === 1 ? "migration" : " migrations");
        migrations.forEach(migrate => migrate(options, this.defaults));
      }
      this.setAll(options);
    }
    async _handleFormInput({target: target}) {
      const form = target.form;
      await this.set(this._parseForm(form));
      form.dispatchEvent(new CustomEvent("options-sync:form-synced", {
        bubbles: true
      }));
    }
    _updateForm(form, options) {
      const currentFormState = this._parseForm(form);
      for (const [key, value] of Object.entries(options)) {
        if (currentFormState[key] === value) {
          delete options[key];
        }
      }
      const include = Object.keys(options);
      if (include.length > 0) {
        deserialize(form, options, {
          include: include
        });
      }
    }
    _parseForm(form) {
      const include = [];
      for (const field of form.querySelectorAll("[name]")) {
        if (field.validity.valid && !field.disabled) {
          include.push(field.name.replace(/\[.*\]/, ""));
        }
      }
      return serialize(form, {
        include: include
      });
    }
    _handleStorageChangeOnForm(changes, areaName) {
      if (areaName === "sync" && changes[this.storageName] && (!document.hasFocus() || !this._form.contains(document.activeElement))) {
        this._updateForm(this._form, this._includeDefaults(changes[this.storageName].newValue));
      }
    }
  }
  webext_options_sync_OptionsSync.migrations = {
    removeUnused(options, defaults) {
      for (const key of Object.keys(options)) {
        if (!(key in defaults)) {
          delete options[key];
        }
      }
    }
  };
  var webext_options_sync = webext_options_sync_OptionsSync;
  const optionsStorage = new webext_options_sync({
    defaults: {
      token: "",
      rootUrl: "https://api.github.com/",
      playNotifSound: false,
      showDesktopNotif: false,
      onlyParticipating: false,
      reuseTabs: false,
      updateCountOnNavigation: false
    },
    migrations: [ webext_options_sync.migrations.removeUnused ]
  });
  var options_storage = __webpack_exports__["a"] = optionsStorage;
}, function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  __webpack_require__.d(__webpack_exports__, "a", function() {
    return queryPermission;
  });
  __webpack_require__.d(__webpack_exports__, "b", function() {
    return requestPermission;
  });
  async function queryPermission(permission) {
    try {
      return browser.permissions.contains({
        permissions: [ permission ]
      });
    } catch (error) {
      console.log(error);
      return false;
    }
  }
  async function requestPermission(permission) {
    try {
      return browser.permissions.request({
        permissions: [ permission ]
      });
    } catch (error) {
      console.log(error);
      return false;
    }
  }
}, function(module, exports, __webpack_require__) {
  "use strict";
  var proto = typeof Element !== "undefined" ? Element.prototype : {};
  var vendor = proto.matches || proto.matchesSelector || proto.webkitMatchesSelector || proto.mozMatchesSelector || proto.msMatchesSelector || proto.oMatchesSelector;
  module.exports = match;
  function match(el, selector) {
    if (!el || el.nodeType !== 1) return false;
    if (vendor) return vendor.call(el, selector);
    var nodes = el.parentNode.querySelectorAll(selector);
    for (var i = 0; i < nodes.length; i++) {
      if (nodes[i] == el) return true;
    }
    return false;
  }
}, , function(module, __webpack_exports__, __webpack_require__) {
  "use strict";
  __webpack_require__.r(__webpack_exports__);
  var _options_storage__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);
  var _lib_permissions_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1);
  const form = document.querySelector("#options-form");
  _options_storage__WEBPACK_IMPORTED_MODULE_0__["a"].syncForm(form);
  form.addEventListener("options-sync:form-synced", () => {
    browser.runtime.sendMessage("update");
  });
  for (const inputElement of form.querySelectorAll("[name]")) {
    if (inputElement.dataset.requestPermission) {
      inputElement.parentElement.addEventListener("click", async event => {
        if (event.target !== inputElement) {
          return;
        }
        if (inputElement.checked) {
          inputElement.checked = await Object(_lib_permissions_service__WEBPACK_IMPORTED_MODULE_1__["b"])(inputElement.dataset.requestPermission);
          _options_storage__WEBPACK_IMPORTED_MODULE_0__["a"].set({
            [inputElement.name]: inputElement.checked
          });
        }
      });
    }
  }
} ]);